# Hướng dẫn sử dụng ssh-tool.
ssh-tool là ứng dụng viết bằng python và trên thư viện netmiko để chạy 1 tập lệnh cho 1 tập các thiết bị nhằm mục đích tiết kiệm thời gian và tránh sai sót khi cấu hình cùng lúc nhiều thiết bị theo một kịch bản (tập lệnh) cố định.

[[_TOC_]]

## I. Thiết lập thông số

### 1. File hosts.csv

Chứa thông tin về host, lưu ý chọn kiểu thiết bị device_type cho phù hợp. Tham khảo thêm tại https://github.com/ktbyers/netmiko/blob/develop/PLATFORMS.md
### 2. File commands.txt

Chứa tập lệnh cần chạy, có các lưu ý sau
- Mỗi lệnh là 1 dòng
- Các lệnh đặc biệt #enable_mode, #exit_enable_mode, @config_mode, #exit_config_mode để đưa thiết bị vào trạng thái enable hay config mode 
### 3. File output.txt

Chứa kết quả thực thi

### 4. File config.py

Về cơ bản có thể chạy các ứng dụng với các thông số mặc định. Nếu người dùng cần tùy chỉnh các thông số thì điều chỉnh ở file này. File này chứa cấu hình đường dẫn các file trên, có thể đổi tên file hay đường dẫn nếu muốn. Ngoài ra có format ghi log file output, có thể điều chỉnh thêm thời gian ghi log nếu muốn bằng cách chỉnh lại định dạng log format (tham khảo thêm tại https://realpython.com/python-logging/)

## II. Download source code

Để chạy ứng dụng thì ta cần download mã nguồn về máy để chạy, có 2 phương pháp

### 1. Dùng git

Nếu đã biết các sử dụng git thì dùng git để download mã nguồn về

git clone https://gitlab.awing.vn/awing-public/sshtool.git

### 2. Download thủ công

Nếu không dùng git thì có thể download thẳng source code về máy, cũng tương tự như dùng git

## III. Cài đặt và chạy ứng dụng
### 1. Cài đặt python

Để chạy ứng dụng, ta cài đặt python version 3.7 trở lên. Truy cập https://www.python.org/ và tìm gói cài đặt tương ứng, sau khi cài đặt thành công thì kiểm tra xem python đã hoạt động chưa bằng cách mở command và gõ lệnh

python

Nếu hiển thị thông tin version và dấu nhắc >>> thì nghĩa là đã cài đặt thành công (ví dụ)
Python 3.7.9 (tags/v3.7.9:13c94747c7, Aug 17 2020, 18:58:18) [MSC v.1900 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license" for more information.

### 2. Cài đặt pip

PIP (Preferred Installer Program), là trình quản lý package trên python, đa phần khi cài đặt python thì đã kèm pip, để kiểm tra ta mở command và gõ lệnh

pip

Nếu hiển thị kết quả nghĩa là đã cài đặt, nếu chưa có thì tham khảo và cài đặt tại đường dẫn https://pip.pypa.io/en/stable/installation/

### 3. Cài đặt các gói cần thiết để chạy ứng dụng

Mở command, enter vào thư mục chứa ứng dụng và chạy lệnh sau để cài đặt các gói

pip install -r requirements.txt --no-cache-dir --compile

### 4. Chạy ứng dụng

Mở command, enter vào thư mục chứa ứng dụng và chạy lệnh sau để chạy ứng dụng

python app.py